﻿
using HarmonyLib;
using TenCrowns.AppCore;
using TenCrowns.GameCore;
using Mohawk.SystemCore;
using System;

namespace SettleAnywhere
{
    public class SettleAnywhereClass : ModEntryPointAdapter
    {
        public const string MY_HARMONY_ID = "dale.SettleAnywhere.patch";
        public Harmony harmony;

        public override void Initialize(ModSettings modSettings)
        {
            harmony = new Harmony(MY_HARMONY_ID);
            harmony.PatchAll();
        }

        public override void Shutdown()
        {
            harmony.UnpatchAll(MY_HARMONY_ID);
        }
    }

    [HarmonyPatch(typeof(Tile), nameof(Tile.isValidFoundLocation), new Type[] { typeof(PlayerType), typeof(TeamType), typeof(bool) })]

    public class PatchSettleAnywhereClass
    {
        static bool Prefix(ref bool __result, Tile __instance, PlayerType ePlayer, TeamType eVisibilityTeam, bool bCheckNoFoundConnection = true)
        {
            using (new UnityProfileScope("Tile.isValidFoundLocation"))
            {
                if (__instance.getRevealedCityTerritory(eVisibilityTeam) != -1)
                {
                    __result = false;
                    return false;
                }
                if (__instance.game().getTurn() < 2)
                {
                    if (!__instance.isRevealedUrban(eVisibilityTeam))
                    {
                        __result = false;
                        return false;
                    }
                    if (!__instance.isConnectedCitySiteActive(eVisibilityTeam))
                    {
                        __result = false;
                        return false;
                    }
                }
                if (bCheckNoFoundConnection)
                {
                    if (__instance.isConnectedNoFound(ePlayer, eVisibilityTeam))
                    {
                        __result = false;
                        return false;
                    }
                }
                __result = true;
                return false;
            }
        }
    }

    [HarmonyPatch(typeof(Tile), nameof(Tile.makeCitySiteUsed), new Type[] { })]

    public class PatchSettleAnywhereFoundClass
    {
        static void Prefix(Tile __instance)
        {
            if(__instance.countAdjacentUrban() == 0)
            {
                __instance.generateUrbanCitySite(1, 3);
            }
            return;
        }
    }
}
